﻿@page "/teams"
@using Models.TeamData
@using Business.Repository.IRepository
@inject ITeamRepository TeamRepository
@inject IJSRuntime JsRuntime
@inject Blazored.LocalStorage.ILocalStorageService localStorage
@inject NavigationManager NavigationManager


<div class="row mt-4">
    <div class="col-8">
        <h4 class="card-title text-info">Teams</h4>
    </div>
    <div class="col-3 offset-1">
        <NavLink href="teams/create" class="btn btn-primary form-control">Add new team</NavLink>
    </div>
</div>
<div class="row mt-4">
    <div class="col-12">
        <table class="table table-bordered table-hover">
            <thead>
                <tr>
                    <th width="5%" class="text-center">#</th>
                    <th width="30%" class="text-center">Name</th>
                    <th width="20%" class="text-center">Sport</th>
                    <th width="10%">
                        Actions
                    </th>
                </tr>
            </thead>
            <tbody>
                @if (Teams.Any())
                {
                    int i = 1;
                    @foreach (var team in Teams)
                    {
                        <tr>
                            <td class="text-center">@i</td>
                            @{i++;}
                            <td class="text-center">@team.Name</td>
                            <td class="text-center">@team.Sport.Name</td>
                            <td>
                                <NavLink href="@($"teams/edit/{team.Id}")" class="btn btn-primary">Edit</NavLink>
                                <button class="btn btn-danger" @onclick="() => HandleDelete(team.Id)">Delete</button>
                            </td>
                        </tr>
                    }
                }
                else
                {
                    <tr>
                        <td colspan="5">No records found</td>
                    </tr>
                }
            </tbody>
        </table>
    </div>
</div>

<DeleteConfirmation IsParentComponentProcessing="IsProcessing" ConfirmationChanged="ConfirmDelete_Click"></DeleteConfirmation>

@code {
    private IEnumerable<TeamDTO> Teams { get; set; } = new List<TeamDTO>();
    private int? DeleteTeamId { get; set; } = null;
    private bool IsProcessing { get; set; } = false;


    protected async override Task OnInitializedAsync()
    {
        Teams = await TeamRepository.GetAllFromSport(await localStorage.GetItemAsync<int>("sportId"));
    }

    private async Task HandleDelete(int teamId)
    {
        DeleteTeamId = teamId;
        await JsRuntime.InvokeVoidAsync("ShowDeleteConfirmationModal");
    }
    public async Task ConfirmDelete_Click(bool isConfirmed)
    {
        IsProcessing = true;
        if (isConfirmed && DeleteTeamId != null)
        {
            await TeamRepository.Delete(DeleteTeamId.Value);
            await JsRuntime.ToastrSuccess("Team deleted successfully!");
            Teams = await TeamRepository.GetAllFromSport(await localStorage.GetItemAsync<int>("sportId"));
        }
        await JsRuntime.InvokeVoidAsync("HideDeleteConfirmationModal");
        IsProcessing = false;
    }
}
